/*
 * Call the page like lyricplay.html#lyricdebug=true
 */
window.addEventListener('load', debugReady, false);

function debugReady() {
	var lyricPlayDebug = location.hash.substring(1).split(',');
	if ( location.hash.length > 0 && location.hash.match('lyricdebug=true') ) {
		
		//Debug code
		(function() {
			var offsetSlider = byId('offsetSlider');
			var offsetValue = byId('offsetValue');
			
			var updateOffsetValue = function() {
				offsetValue.value = offsetSlider.value;
			};
			
			offsetSlider.addEventListener('change', function() {
				updateOffsetValue();
			}, true);
			
			updateOffsetValue();
			
			byId('visualisationLinks').addEventListener('click', function(e) {
				var link = e.target;
				if (link) {
					link.href += ',' + offsetValue.value + ',0,lyricdebug=true' ;
					location.hash = link.href.split('#')[1]
					location.reload();
					e.preventDefault();
				}
			}, true);
			
			var fragment = document.createDocumentFragment();
			for ( i in sampleLyrics ) {
				var list = document.createElement('li');
				var anchor = document.createElement('a');
				anchor.href='#' + i.toString();
				anchor.innerHTML = i.toString() + ' ( ' + sampleLyrics[i].styles[0].texts.effect  + ' )' ;
				list.appendChild(anchor);
				fragment.appendChild(list);
			}
			var visualLinks = byId('visualisationLinks');
			visualLinks.appendChild(fragment);
			
		}());
		
		var colourPalette = document.createElement('div');
		var ul = document.createElement('ul');
		colourPalette.id = 'colourPalette';
		var fragment = document.createDocumentFragment();
				
		var colourParamterWhitelist = ['textShadowColor', 'glowColorHighlight', 'textColor', 'textColorHighlight', 'strokeColorHighlight', 'textColorBottom', 'textColorTop', 'textColorTopEnd', 'strokeColor', 'backgroundGradient'];
		
		for (colour in colourParamterWhitelist) {
			 var li = document.createElement('li');
			 
			 if ( sampleLyrics[lyricPlayDebug[0]].styles[0].texts.text[colourParamterWhitelist[colour]] ) {
				 var currentColour = lyricStyle.rgbaHexToCssDecimal(sampleLyrics[lyricPlayDebug[0]].styles[0].texts.text[colourParamterWhitelist[colour]]);
				 li.style.backgroundColor = currentColour;
			 } else if ( sampleLyrics[lyricPlayDebug[0]].styles[0].scenes.scene[colourParamterWhitelist[colour]] ) {
				 if (colourParamterWhitelist[colour] === 'backgroundGradient' ) {
					 //Multiple colours exist here...
					 var currentGradient = lyricStyle.generateCSSGradient(sampleLyrics[lyricPlayDebug[0]].styles[0].scenes.scene[colourParamterWhitelist[colour]], sampleLyrics[lyricPlayDebug[0]].styles[0].scenes.scene['backgroundAngle']);
					 li.style.backgroundImage = currentGradient;
				 }
			 } else {
				 //console.log('not found: ', colourParamterWhitelist[colour]);
			 }
			 
			 li.innerHTML = colourParamterWhitelist[colour];
			 fragment.appendChild(li);
		}
		
		ul.appendChild(fragment);
		colourPalette.appendChild(ul);
		
		document.body.appendChild(colourPalette);
		
		byId('debug').style.display = 'block' ;
	    
	    lyricPlay.play(sampleLyrics[lyricPlayDebug[0]], parseInt(lyricPlayDebug[1]), parseInt(lyricPlayDebug[2]));
	}
}

/*
 * This code belongs in the perspective animation, but only if we decide to keep the bouncing effect
 *
 * Commenting out the bouncing as it does not perform well on 3G
	byId("lyricsList").addEventListener("webkitAnimationEnd", function(_e) {
	//if (_e.animationName === "bouncing") {
		byId("lyricsList").className = '';
		document.head.removeChild(animationStyleNode);
	//}
}, false);

byId("lyricsList").addEventListener("webkitTransitionEnd", function(e) {
	if(e.propertyName === '-webkit-transform') {
		var translateY = getComputedStyle(byId("lyricsList")).webkitTransform.split('(')[1].split(')')[0].split(',')[5];
		var animationStyle = '@-webkit-keyframes testingBounce {';
		animationStyle += ' 0% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY))  + 'px)} ';
		animationStyle += ' 14% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY) + 12)  + 'px)} ';
		animationStyle += ' 28% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY))  + 'px)} ';
		animationStyle += ' 42% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY) + 7)  + 'px)} ';
		animationStyle += ' 56% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY))  + 'px)} ';
		animationStyle += ' 70% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY) + 3)  + 'px)} ';
		animationStyle += ' 100% {-webkit-transform: translateZ(0px) translateY(' + (parseInt(translateY))  + 'px)} ';
		animationStyle += '}';
		animationStyleNode = lyricStyle.insertCSSNode(animationStyle);
		byId("lyricsList").className = "testingBounce";
	}
}, true);
*/